;        _________  _____
;        \___  ___\ \  _ \         TRANSFILE PC<=>CPC TRANSFER UTILITY
;            \ \     \ \\ \_       COPYRIGHT 1995,96 MICROTEK SOFTWARE
;             \ \     \  __ \
;              \ \     \ \ \ \     SOURCE: CPCTR.ASM Z80 ASSEMBLY MODULE
;               \ \     \ \ \ \    REQUIREMENTS: 3.3MHZ OR FASTER CPU
;                                  NOTE: FIRMWARE REDIRECTION PROG REQUIRED

				; This routine is called when the loading/saving
				; firmware instruction is used. It is necessary
				; to redirect the firmware routines to call the
				; appropriate lines in this code

        PUSH    BC		; There are two addresses for the CPC printer port
        LD      BC,#EF00	; EFxx which sends and F5xx which receives
        LD      A,128
        OUT     (C),A		; Send ready to recieve
        LD      BC,#F500
WL1:    IN      A,(C)
        BIT     6,A
        JR      Z,WL1		; Wait in loop until bit 6 high
        LD      BC,#EF00
        LD      A,0
        OUT     (C),A		; Clear ready to recieve
        POP     BC
        LD      A,B
        CALL    TRAN		; When called, filetype=B transmit this
GC:     LD      A,(HL)
        CALL    TRAN		; Transmit first char in HL (filename)
        INC     HL
        DEC     B
        JR      NZ,GC		; until filename is passed through
        PUSH    BC
        LD      BC,#EF00
        LD      A,0		; send 0
        OUT     (C),A
        POP     BC
        CALL    BIGWAIT		; wait for the PC to retrieve the file
        CALL    BIGWAIT
        LD      HL,FTYPE
        LD      DE,FTYPE
        CALL    REC
        LD      A,(FTYPE)
        CP      #01
        JR      Z,STREC
        LD      HL,64
        PUSH    HL
        POP     AF
        RET

        ; This section transmits a byte stored in A

TRAN:   PUSH    BC		; store register on stack
        LD      B,8		; counter for bits in byte
        LD      C,A
K0:     PUSH    BC
        LD      BC,#F500
K1:     IN      A,(C)
        BIT     6,A
        JR      NZ,K1		; wait for bit 6 set
        POP     BC
        LD      A,0		; set bit to be sent to 0
        BIT     7,C		; if the bit to be sent is otherwise 
        JR      Z,K2
        LD      A,128		; then set bit to be sent to 1
K2:     PUSH    BC
        LD      BC,#EF00	; send that bit to pc
        OUT     (C),A
        LD      BC,#F500
K3:     IN      A,(C)
        BIT     6,A
        JR      Z,K3		; wait to send next bit
        POP     BC
        SLA     C		; shift bits in the byte
        DEC     B
        JR      NZ,K0		; loop until all bits in the byte are sent
        POP     BC
        RET
        ;

        ; This section waits and then recieves all the file information from the PC

STREC:  CALL    BIGWAIT		; wait
        LD      HL,START	; get start addr
        LD      DE,START+1
        CALL    REC
        LD      HL,LENGTH	; get file length
        LD      DE,LENGTH+1
        CALL    REC
        LD      HL,EXEC		; get exe address
        LD      DE,EXEC+1
        CALL    REC
        LD      HL,FTYPE	; get file type
        LD      DE,FTYPE
        CALL    REC
        LD      HL,1
        PUSH    HL
        POP     AF
        LD      HL,#C000	; send back local stuff as is from firmware call
        LD      DE,(START)
        LD      BC,(LENGTH)
        LD      A,(FTYPE)
        RET			; return
        ;

        ; This routine recieves all the data and puts it into memory

        CALL    BIGWAIT
        LD      A,H
        OR      L
        JR      NZ,EXT
        LD      HL,(START)	; get the start addr
EXT:    LD      DE,(LENGTH)	; get the length
        PUSH    HL
        ADD     HL,DE		; add them together and see if HL (counter)
        LD      D,H		; was reached the end addr (start+length)
        LD      E,L
        POP     HL
        CALL    REC		; recieve byte
        LD      HL,1
        PUSH    HL
        POP     AF
        LD      HL,(EXEC)	; store exec addr
        RET
        ;
REC:    LD      B,8		; length of bits
        LD      C,0
        INC     DE
J0:     PUSH    BC
        LD      A,128
        LD      BC,#EF00
        OUT     (C),A		; transmit ready signal
        CALL    WAIT
        LD      BC,#F500
        IN      A,(C)		; get bit
        PUSH    AF
        LD      A,0
        LD      BC,#EF00
        OUT     (C),A		; transmit clear signal
        CALL    WAIT
        POP     AF
        POP     BC
        BIT     6,A		; if bit 6 is set then J1
        JR      Z,J1
        SET     0,C		; else set bit 0 of C
J1:     DEC     B
        JR      Z,J2
        SLA     C		; shift bits of C to set next bit if necessary
        JR      J0		; continue until counter reaches 0 (whole byte)
J2:     LD      B,8
        LD      (HL),C
        INC     HL
        LD      C,0
        LD      A,H
        CP      D
        JR      NZ,J0
        LD      A,L
        CP      E
        JR      NZ,J0
        RET
        ;
WAIT:   PUSH    AF		; simple short wait loop for synchronization
        LD      A,7
J3:     DEC     A
        CP      0
        JR      NZ,J3
        POP     AF
        RET
        ;
BIGWAIT:PUSH    HL		; larger wait loop for disks
        LD      HL,#FFFF
BW1:    DEC     HL
        LD      A,H
        OR      L
        JR      NZ,BW1
        POP     HL
        RET
        ;

        ; devpac instructions for storing bytes/words in memory

FTYPE:  DEFB    0
START:  DEFW    0
LENGTH: DEFW    0
EXEC:   DEFW    0

